#include "atnd.h"

void versionGuide(double v, bool comments) {
    using namespace std;

    cerr << "atnd C++ Version " << v << "\n" << endl;

    if(comments) {
        cerr << "atnd -a2 -p567 file        # 2 lines after line-567 " << endl
            << "atnd -b3 -p567 file        # 3 lines before line-567 " << endl
            << "atnd -c4 -p567 file        # 4 lines before line-567 and 4 lines after line-567" << endl
            << "atnd -c4 -p567 -n file     # A number appears at the beginning of each line. " << endl
            << "atnd -h8 file              # Line-1, Line-2, Line-3, ..., Line-8 " << endl
            << "atnd -h8 < file            # Line-1, Line-2, Line-3, ..., Line-8 " << endl
            << "atnd -i90-123 file         # Line-90, Line-91, Line-92, ..., Line-123 " << endl
            << "atnd -LF -p567 file        # Count lines. Record the max span from LF to LF. " << endl
            << "atnd -LF -p567 -s, file    # Record the max span from separator to separator. " << endl
            << "atnd -LF -p567 -s\\x2C file # Record the max span from separator to separator. " << endl
            << "atnd -p567 file            # line-567 " << endl
            << "atnd -p567 -l file         # Show how large the buffer is. " << endl
            << "atnd -t9 file              # 9 lines before EOF " << endl
            << "atnd -V                    # version " << endl
            << "atnd -VC                   # version with comments " << endl
            << "atnd -z80                  # Use a buffer of 80 bytes. " << endl
            << "DIR | atnd -LF -=DIR -p9   # Display a label (DIR) instead of files. " << endl;
    } else {
        cerr << "atnd -a2 -p567 file        " << endl
            << "atnd -b3 -p567 file        " << endl
            << "atnd -c4 -p567 file        " << endl
            << "atnd -c4 -p567 -n file     " << endl
            << "atnd -h8 file              " << endl
            << "atnd -h8 < file            " << endl
            << "atnd -i90-123 file         " << endl
            << "atnd -LF -p567 file        " << endl
            << "atnd -LF -p567 -s, file    " << endl
            << "atnd -LF -p567 -s\\x2C file " << endl
            << "atnd -p567 file            " << endl
            << "atnd -p567 -l file         " << endl
            << "atnd -t9 file              " << endl
            << "atnd -V                    " << endl
            << "atnd -VC                   " << endl
            << "atnd -z80                  " << endl
            << "DIR | atnd -LF -=DIR -p9   " << endl;
    }

    exit(1);
}
