#include "atnd.h"

bool StandardInputLine::standard_input_output(std::string & label) {
    using namespace std;

    bool b = false;
    int maximum = 0;
    int line_number = 1;
    int m = 0;
    int n = 0;
    string *p = new string("");
    string line = EMPTY;
    string save = EMPTY;

    while( cin.getline(buffer, BUFFER_SIZE) ) {
        delete p;
        p = new string(buffer);
        line = *p;

        n += 1;
        if(n == point) {
            b = true;
            save = line;
        }

        m = line.length();
        if (m > maximum) {
            line_number = n;
            maximum = m;
        }

    }

    if(measure) {
        cout << label << ": " << n;
        if(n == 1) {
            cout << " line";
        } else {
            cout << " lines" << endl;
        }

        cout << "maximum LF-to-LF span of " << maximum << " bytes (line-" << line_number << ")" << endl;
    }

    cout << save << endl;
    return b;
}
