#include "keyun.h"

void versionGuide(double v, bool comments, bool loud) {
    using namespace std;

    const string NEW_LINE("\n");
    string messages;
    stringstream os;
    os << "keyun Version " << v << "\n" << NEW_LINE;

    if(comments) {
        os << "keyun                     # Read records and arrange lines. " << NEW_LINE;
        os << "keyun -f                  # EIGHT equals eight. " << NEW_LINE;
        os << "keyun -o new              # Read records to produce a new file. " << NEW_LINE;
        os << "keyun -o-                 # Display lines without producing a new file. " << NEW_LINE;
        os << "keyun -e -o new           # 0Dh is removed from every line. " << NEW_LINE;
        os << "keyun -r                  # Arrange lines in descending order. " << NEW_LINE;
        os << "keyun -u                  # Display a line for each unique summary. " << NEW_LINE;
        os << "keyun -y                  # Do not remove binary.tmp " << NEW_LINE;
        os << "keyun -V                  # version " << NEW_LINE;
        os << "keyun --help              # Display comments. " << NEW_LINE;
        os << "keyun -s --help > file    # Produce a help file. ";
    } else {
        os << "keyun --help ";
    }

    messages = os.str();
    if(loud) {
        cerr << messages << endl;
    } else { // -s
        cout << messages << endl;
    }

    exit(1);
}
