CC        = bcc32
LINKER    = ilink32

INCLUDE = -I"C:\borland\bcc55\Include"
LIB     = /L"C:\borland\bcc55\Lib"

CFLAGS = -O2 -w 
LFLAGS = /Tpe /c /ap
RFLAGS = -32

TARGET = obot.exe
OBJS   = numbered.obj guide.obj obotmain.obj represented_in_hexadecimal.obj 

ALL : $(TARGET)

numbered.obj: Numbered.cpp
	$(CC) $(INCLUDE) -c Numbered.cpp
guide.obj: Guide.cpp
	$(CC) $(INCLUDE) -c Guide.cpp
obotmain.obj: obotMain.cpp
	$(CC) $(CFLAGS) $(INCLUDE) -c obotMain.cpp
represented_in_hexadecimal.obj: Represented_in_hexadecimal.cpp
	$(CC) $(INCLUDE) -c Represented_in_hexadecimal.cpp

$(TARGET): $(OBJS) $(RESFILES)
	$(LINKER) $(LFLAGS) $(LIB) $(OBJS) c0x32.obj,$(TARGET),,cw32.lib import32.lib,,$(RESFILES)

clean:
	del *.obj
	del *.tds
	del *.il*
	del *.map
