CC        = bcc32
LINKER    = ilink32
RC        = brcc32

INCLUDE = -I"C:\borland\bcc55\Include"
LIB     = /L"C:\borland\bcc55\Lib"

CFLAGS = -O2 -w 
LFLAGS = /Tpe /c /ap

TARGET = sortk.exe
OBJS   = arrange.obj compare.obj counting.obj guide.obj line.obj numbered.obj put_text.obj runlength.obj segmented.obj sortkMain.obj standard_io.obj summary_details.obj 
RESFILES = sortkResource.res

ALL : $(TARGET)

arrange.obj: arrange.cpp
	$(CC) $(INCLUDE) -c arrange.cpp
compare.obj: compare.cpp
	$(CC) $(INCLUDE) -c compare.cpp
counting.obj: counting.cpp
	$(CC) $(INCLUDE) -c counting.cpp
guide.obj: Guide.cpp
	$(CC) $(INCLUDE) -c Guide.cpp
line.obj: Line.cpp
	$(CC) $(INCLUDE) -c Line.cpp
numbered.obj: Numbered.cpp
	$(CC) $(INCLUDE) -c Numbered.cpp
put_text.obj: put_text.cpp
	$(CC) $(INCLUDE) -c put_text.cpp
runlength.obj: runLength.cpp
	$(CC) $(INCLUDE) -c runLength.cpp
segmented.obj: Segmented.cpp
	$(CC) $(INCLUDE) -c Segmented.cpp
sortkmain.obj: sortkMain.cpp
	$(CC) $(CFLAGS) $(INCLUDE) -c sortkMain.cpp
standard_io.obj: standard_io.cpp
	$(CC) $(INCLUDE) -c standard_io.cpp
summary_details.obj: summary_details.cpp
	$(CC) $(INCLUDE) -c summary_details.cpp
sortkResource.res: sortkResource.rc
	$(RC) $(RFLAGS) sortkResource.rc

$(TARGET): $(OBJS) $(RESFILES)
	$(LINKER) $(LFLAGS) $(LIB) $(OBJS) c0x32.obj,$(TARGET),,cw32.lib import32.lib,,$(RESFILES)
clean:
	del *.obj
	del *.tds
	del *.il*
	del *.map
