#include "sutai.h"

/*
sortk C++ Version 1.22
Comparing phrases from Field-2 to Field-3, for example, to arrange lines in descending order
Copyright 2019 Sogaya

gcc (GCC) 3.4.2 (mingw-special)
Borland C++ 5.5.1 for Win32

*/

char bits[ FIELD_COUNT + 1 ];
extern int check_ID[LIMIT_OF_MY_MEMORY];

bool extensionEqualsCSV(std::string & name) {
    using namespace std;

    bool csv = false;
    const int DOT_SIZE = 1;
    const string CAPITAL_CSV("CSV");
    const string CSV("csv");
    const string DOT(".");

    int q = name.find(DOT);
    string extention;
    if(q >= 0) {
        q += DOT_SIZE;
        extention = name.substr(q);
        if(CSV == extention) {
            csv = true;
        } else if(CAPITAL_CSV == extention) {
            csv = true;
        }

    }

    return csv;
}

int main(int argc, char *argv[]) {
    using namespace std;

    const bool STOP = true;
    const bool WITH_COMMENTS = true;
    const bool WITHOUT_COMMENTS = false;
    const int BITS_SIZE = 2;
    const int GAP = ' ';
    const int JOINT_TERM_SIZE = 2;
    const int NEW_LINE_ZERO = 2; // buffer shall include '\n' and '\0'.
    const int NOT_CONVERTED = -1;
    const int NOT_FOUND = -1;
    const int SEPARATOR_TERM_SIZE = 2;
    const int USED_AS_QUOTE_SIZE = 2;
    const string ADD_ID("-#");
    const string ALL_LINES_SHARE_FIELD_COUNT("-$");
    const string DESCENDING("-r");
    const string DO_NOT_CHECK_EXTENSION("-x-");
    const string DO_NOT_REMOVE_TEMPORARY_BINARY_FILE("-y");
    const string EMPTY("");
    const string EUC_JP_TERM("-e");
    const string FIELD_COUNT_TERM("-a");
    const string FLOATING_POINT_TERM("-g");
    const string HELP("--help");
    const string IGNORE_CONTROL_CHARACTERS("-i");
    const string INTEGER_TERM("-n");
    const string INTERVAL("-k");
    const string LINE_BUFFER_SIZE("-l");
    const string LINE_FOR_EACH_UNIQUE_SUMMARY("-u");
    const string MAXIMUM_LINE_COUNT("-U");
    const string NEW_FILE("-o");
    const string NO_COMBINING("-c-");
    const string NOT_CASE_SENSITIVE("-f");
    const string OMIT_P_AND_Q("-p");
    const string PRODUCE_SETTING_TEXT("-%");
    const string QUOTES("-q");
    const string REDUCE_BINARY_FILE_SIZE("-~");
    const string REPORT_ID("-!");
    const string SKIP_SPACE("-b");
    const string SILENT("-s");
    const string SINGLE_FIELD("-j");
    const string SIZE_OF_BUFFER("-z");
    const string STANDARD_OUT("-o-");
    const string UTF_8_TERM("-8");
    const string VERSION_WITH_COMMENTS("-VC");
    const string VERSION_WITHOUT_COMMENTS("-V");

    bool add_ID = false;
    bool assume_shift_jis_appears = false;
    bool carriage_return = true;
    bool case_sensitive = true;
    bool check_extension = true;
    bool check_field_count = false;
    bool combining_character = true;
    bool csv = false;
    bool descending = false;
    bool line_buffer_size = false;
    bool loud = true;
    bool new_file = false;
    bool produce_setting_text = false;
    bool remove_temporary_binary_file = true;
    bool remove_separators = false;
    bool reduce_binary = false;
    bool report_ID = false;
    bool skip_space = false;
    bool substituted = false;
    bool surge = false;
    bool unique_summary = false;
    char *b;
    char *edge;
    char *supplied;
    char BITS[] = "-h";
    char file_name[ FILE_NAME_SIZE + 1 ];
    char MINUS_J2[] = "-j2";
    char new_name[ FILE_NAME_SIZE + 1 ];
    char JOINT[] = "-v";
    char SEPARATOR[] = "-t";
    char USED_AS_QUOTE[] = "-w";
    int body_length = 1;
    int buffer_size = BUFFER_SIZE;
    int demands = FIELD_COUNT;
    int demands_1 = demands + 1;
    int direction = 1; // direction > 0
    int exit_code = 0;
    int field_count = FIELD_COUNT;
    int file_name_size, maximum;
    int from = 1;
    int interval_0 = from;
    int to = 1;
    int interval_1 = to;
    int joint = BELL;
    int line_count = 0;
    int manager = PHRASES;
    int q = NOT_FOUND;
    int quote = QUOTE;
    int record_size = RECORD_SIZE;
    int separator = GAP;
    int upper_limit = UPPER_LIMIT;
    long z = (long)BUFFER_SIZE;
    Numbered *n = new Numbered(MINUS_J2);
    string *p = new string("");
    string argument;
    string fileName = EMPTY;
    string newName = EMPTY;

    for(int i = 1; i < argc; ++i) {
        delete p;
        p = new string(argv[i]);
        argument = *p;

        if(ADD_ID == argument) {
            add_ID = true;
        } else if(ALL_LINES_SHARE_FIELD_COUNT == argument) {
            check_field_count = true;
        } else if(DESCENDING == argument) {
            descending = true;
        } else if(DO_NOT_CHECK_EXTENSION == argument) {
            check_extension = false;
        } else if(DO_NOT_REMOVE_TEMPORARY_BINARY_FILE == argument) {
            remove_temporary_binary_file = false;
        } else if(EUC_JP_TERM == argument) {
            carriage_return = false;
        } else if(FLOATING_POINT_TERM == argument) {
            manager = FLOATING_POINT_NUMBERS;
        } else if(HELP == argument) {
            delete n; delete p;
            versionGuide(VERSION, WITH_COMMENTS, loud);
        } else if(IGNORE_CONTROL_CHARACTERS == argument) {
            assume_shift_jis_appears = true;
        } else if(INTEGER_TERM == argument) {
            manager = INTEGERS;
        } else if(LINE_BUFFER_SIZE == argument) {
            line_buffer_size = true;
        } else if(LINE_FOR_EACH_UNIQUE_SUMMARY == argument) {
            unique_summary = true;
        } else if(NEW_FILE == argument) {
            new_file = true;
        } else if(NO_COMBINING == argument) {
            combining_character = false;
        } else if(NOT_CASE_SENSITIVE == argument) {
            case_sensitive = false;
        } else if(OMIT_P_AND_Q == argument) {
            substituted = true;
        } else if(PRODUCE_SETTING_TEXT == argument) {
            produce_setting_text = true;
        } else if(QUOTES == argument) {
            remove_separators = true;
        } else if(REDUCE_BINARY_FILE_SIZE == argument) {
            reduce_binary = true;
        } else if(REPORT_ID == argument) {
            report_ID = true;
        } else if(SILENT == argument) {
            loud = false;
        } else if(SKIP_SPACE == argument) {
            skip_space = true;
        } else if(STANDARD_OUT == argument) {
            newName = EMPTY;
        } else if(UTF_8_TERM == argument) {
            carriage_return = false;
        } else if(VERSION_WITH_COMMENTS == argument) {
            delete n; delete p;
            versionGuide(VERSION, WITH_COMMENTS, loud);
        } else if(VERSION_WITHOUT_COMMENTS == argument) {
            delete n; delete p;
            versionGuide(VERSION, WITHOUT_COMMENTS, loud);
        } else {
            b = argv[i];
            edge = & b[0];

            b = strstr(argv[i], BITS);
            if(b == edge) {
                b += BITS_SIZE;
                body_length = strlen(b);
                if(body_length > field_count) {
                    body_length = field_count;
                    memcpy(bits, b, body_length);
                    bits[body_length] = '\0';
                } else {
                    demands = field_count - body_length;
                    try {
                        demands_1 = demands + 1;
                        supplied = new char[demands_1];
                        supplied[demands] = '\0';
                        memset(supplied, SET, demands);
                        strcpy(bits, b);
                        strcat(bits, supplied);
                        delete[] supplied;
                    } catch(...) {
                        if(loud) {
                            cerr << "new char[] error-4: " << demands_1 << " bytes" << endl;
                            exit(1);
                        } else {
                            body_length = field_count;
                            memcpy(bits, b, body_length);
                            bits[body_length] = '\0';
                        }

                    }

                }

                continue;
            }

            q = argument.find(FIELD_COUNT_TERM);
            if(q == 0) {
                delete n;
                n = new Numbered(argument);
                field_count = n->number();
                if ( FIELD_COUNT_TERM == n->parameter() ) {
                    if(field_count == NOT_CONVERTED) {
                        field_count = FIELD_COUNT;
                    }

                    continue;
                }

                field_count = FIELD_COUNT;
            }

            q = argument.find(INTERVAL);
            if(q == 0) {
                delete n;
                n = new Numbered(argument, FIELD_COUNT);
                if( n->trimmed_sequence() ) {
                    interval_1 = n->number();
                    interval_0 = n->subnumber();
                    if( INTERVAL == n->parameter() ) {
                        if(interval_0 == NOT_CONVERTED) {
                            interval_0 = 1;
                            interval_1 = 1;
                        }

                        direction = interval_1 - interval_0;
                        if(direction >= 0) {
                            from = interval_0;
                            to = interval_1;
                            surge = true;
                            continue;
                        } else {
                            from = interval_1;
                            to = interval_0;
                            surge = true;
                            continue;
                        }

                    }

                }

                interval_0 = 1;
                interval_1 = 1;
            }

            b = strstr(argv[i], JOINT);
            if(b == edge) {
                joint = punctuation(argv[i], JOINT_TERM_SIZE);
                continue;
            }

            q = argument.find(MAXIMUM_LINE_COUNT);
            if(q == 0) {
                delete n;
                n = new Numbered(argument);
                upper_limit = n->number();
                if ( MAXIMUM_LINE_COUNT == n->parameter() ) {
                    if(upper_limit == NOT_CONVERTED) {
                        upper_limit = UPPER_LIMIT;
                    }

                    continue;
                }

                upper_limit = UPPER_LIMIT;
            }

            b = strstr(argv[i], SEPARATOR);
            if(b == edge) {
                separator = punctuation(argv[i], SEPARATOR_TERM_SIZE);
                continue;
            }

            q = argument.find(SINGLE_FIELD);
            if(q == 0) {
                delete n;
                n = new Numbered(argument);
                from = n->number();
                if ( SINGLE_FIELD == n->parameter() ) {
                    if(from == NOT_CONVERTED) {
                        from = 1;
                        to = 1;
                    }

                    to = from;
                    continue;
                }

                from = 1;
                to = 1;
            }

            q = argument.find(SIZE_OF_BUFFER);
            if(q == 0) {
                delete n;
                n = new Numbered(argument);
                buffer_size = n->number();
                if ( SIZE_OF_BUFFER == n->parameter() ) {
                    if(buffer_size == NOT_CONVERTED) {
                        buffer_size = BUFFER_SIZE;
                    }

                    continue;
                }

                buffer_size = BUFFER_SIZE;
            }

            b = strstr(argv[i], USED_AS_QUOTE);
            if(b == edge) {
                quote = punctuation(argv[i], USED_AS_QUOTE_SIZE);
                continue;
            }

            if(new_file) {
                newName = argument;
                new_file = false;
            } else {
                fileName = argument;
            }

        } // if

    } // for(int i = 1; i < argc; ++i)

    if(surge) {
        surge_of_set_bits(bits, field_count, from, to);
    }

    new_name[FILE_NAME_SIZE] = '\0';
    strncpy(new_name, newName.c_str(), FILE_NAME_SIZE);

    file_name[FILE_NAME_SIZE] = '\0';
    strncpy(file_name, fileName.c_str(), FILE_NAME_SIZE);
    file_name_size = strlen(file_name);
    if(file_name_size == 0) {
// standard input
        if(buffer_size == BUFFER_SIZE) {
            if(add_ID) {
                buffer_size = BLOCK_SIZE - END_ID;
            } else {
                buffer_size = BLOCK_SIZE - END;
            }

        }

        z = (long)buffer_size;
        if(line_buffer_size) {
            cout << buffer_size << " bytes" << endl;
        }

        Standard_input *d = new Standard_input(bits, z, separator, field_count, joint, manager, quote, upper_limit, assume_shift_jis_appears, combining_character, remove_separators, skip_space, substituted, add_ID, carriage_return, case_sensitive, descending);

        if(check_field_count) {
            exit_code = d->standard_input_counting();
        } else {
            if(add_ID) {
                line_count = d->standard_input_binary_output_adding_ID();
            } else {
                if(reduce_binary) {
                    line_count = d->standard_input_line_for_each_summary();
                } else {
                    line_count = d->standard_input_binary_output();
                }

            }

            if(line_count > 0) {
                exit_code = 0;
                record_size = d->recordSize();
            } else {
                exit_code = line_count;
                delete d; delete n; delete p;
                return exit_code;
            }

        }

        delete d;
    } else {
// file
        if(check_extension) {
            csv = extensionEqualsCSV(fileName);
            if(csv) {
                separator = COMMA;
            }

        }

        Line *e = new Line(fileName);
        line_count = e->checkLineCount(STOP);

        if(buffer_size == BUFFER_SIZE) {
            maximum = e->maximumLineSize();
            buffer_size = maximum + NEW_LINE_ZERO;
        }

        z = (long)buffer_size;
        if(line_buffer_size) {
            cout << buffer_size << " bytes" << endl;
        }

        SummaryDetails *s = new SummaryDetails(file_name, bits, new_name, z, separator, field_count, joint, manager, quote, upper_limit, assume_shift_jis_appears, combining_character, remove_separators, skip_space, substituted, add_ID, carriage_return, case_sensitive, descending);

        if(check_field_count) {
            exit_code = s->counting();
        } else {
            if(add_ID) {
                line_count = s->selectingAddingID();
            } else {
                if(reduce_binary) {
                    line_count = s->line_for_each_summary();
                } else {
                    line_count = s->selecting();
                }

            }

            if(line_count > 0) {
                exit_code = 0;
                record_size = s->recordSize();
            } else {
                exit_code = line_count;
                delete e; delete s; delete n; delete p;
                return exit_code;
            }

        }

        delete e; delete s;
    }

    if(produce_setting_text) {
        producingText(SETTING_TEXT, TEMPORARY_BINARY, new_name, line_count, manager, record_size, add_ID, case_sensitive, report_ID, carriage_return, descending, loud, remove_temporary_binary_file, unique_summary, reduce_binary);
    }

    if(unique_summary) {
        exit_code = arranging_unique_lines_to_produce_text(TEMPORARY_BINARY, new_name, line_count, manager, record_size, add_ID, carriage_return, case_sensitive, descending);
    } else {
        exit_code = arranging_to_produce_text(TEMPORARY_BINARY, new_name, line_count, manager, record_size, add_ID, carriage_return, case_sensitive, descending);
    }

    if(remove_temporary_binary_file) {
        remove(TEMPORARY_BINARY);
    }

    if(report_ID) {
        for(int h = 0; h < LIMIT_OF_MY_MEMORY && check_ID[h] > 0; ++h) {
            cout << "Line-" << check_ID[h] << endl;
        }

    }

    delete n; delete p;
    return exit_code;
}

int punctuation(char *p, int q) {
    const int GAP = ' ';
    const int GREATER_THAN = '>';
    const int LESS_THAN = '<';
    const int TAB = '\t';
    const int VERTICAL_LINE = '|';
    const int X_SIZE = 1;
    const int YEN = '\\';
    const int YEN_SIZE = 1;
    char *stop;
    char ASCII_KATAKANA[] = "                                 !\"#$%&'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~                                  ";
    char hexadecimal[3] = {0, 0, 0};
    unsigned char uc = (unsigned char)p[q];
    int c = (int)uc;
    int k;
    int separator = COMMA;

    if(c == YEN) {
        q += YEN_SIZE;
        uc = (unsigned char)p[q];
        c = (int)uc;
        switch(c) {
        case 'A':
            return LESS_THAN;
        case HE: // 0xCD
            return LESS_THAN;
        case 'l':
            return VERTICAL_LINE;
        case 's':
            return GAP;
        case 't':
            return TAB;
        case 'v':
            return GREATER_THAN;
        case 'x':
            q += X_SIZE;
            memcpy(hexadecimal, &p[q], 2);
            separator = (int)strtol(hexadecimal, &stop, 16);
            return separator;
        default:
            return COMMA;
        }

    }

    for(k = 0; ASCII_KATAKANA[k]; k++) {
        if(ASCII_KATAKANA[k] == c) {
            separator = k;
        }

    }

    return separator;
}
