#include "kanji_union.h"

void versionGuide(double v, bool comments) {
    using namespace std;

    cerr << "sjisEUC C++ Version " << v << "\n" << endl;

    if(comments) {
        cerr << "sjisEUC SJIS            # Produce sjisEUC.txt " << endl
            << "sjisEUC SJIS EUC        # Produce a new file. " << endl
            << "sjisEUC < SJIS > EUC    # Every line includes 0Dh. " << endl
            << "sjisEUC -a SJIS         # Acquire a table name from sete.txt " << endl
            << "sjisEUC -b SJIS         # Produce binary.tmp " << endl
            << "sjisEUC -b SJIS SJIS    # Produce and rename binary.tmp " << endl
            << "sjisEUC -b -y SJIS      # Do not remove binary.tmp " << endl
            << "sjisEUC -CRLF SJIS      # Every line includes 0Dh. " << endl
            << "sjisEUC -CRLF SJIS EUC  # Every line includes 0Dh. " << endl
            << "sjisEUC -d SJIS         # Do not search a table. " << endl
            << "sjisEUC -LF SJIS        # 0Dh is removed from every line. " << endl
            << "sjisEUC -s SJIS         # Skip control characters except 0Ah. " << endl
            << "sjisEUC -t SJIS EUC     # SJIS has the same time as EUC. " << endl
            << "sjisEUC -w SJIS         # -w shows which table sjisEUC uses." << endl
            << "sjisEUC -V              # version " << endl
            << "sjisEUC -VC             # version with comments " << endl;
    } else {
        cerr << "sjisEUC SJIS             " << endl
            << "sjisEUC SJIS EUC        " << endl
            << "sjisEUC < SJIS > EUC    " << endl
            << "sjisEUC -a SJIS         " << endl
            << "sjisEUC -b SJIS         " << endl
            << "sjisEUC -b SJIS SJIS    " << endl
            << "sjisEUC -b -y SJIS      " << endl
            << "sjisEUC -CRLF SJIS      " << endl
            << "sjisEUC -CRLF SJIS EUC  " << endl
            << "sjisEUC -d SJIS         " << endl
            << "sjisEUC -LF SJIS        " << endl
            << "sjisEUC -s SJIS         " << endl
            << "sjisEUC -t SJIS EUC     " << endl
            << "sjisEUC -w SJIS         " << endl
            << "sjisEUC -V              " << endl
            << "sjisEUC -VC             " << endl;
    }

    exit(1);
}
