#include "obot.h"

void versionGuide(double v, bool comments) {
    using namespace std;

    cerr << "obot C++ Version " << v << "\n" << endl;

    if(comments) {
        cerr << "obot -b2048 text      # Read 2048 bytes. " << endl
            << "obot -c20 text        # Produce a table that has 20 fields or less. " << endl
            << "obot -m3 text         # 3 lines can be represented in hexadecimal as 20 0D 0A.." << endl
            << "obot -m3 -s\\x2C text  # CSV " << endl
            << "obot -m45 -r20 text   # Produce a table that has 20 rows or less. " << endl
            << "obot exe              # EXE can be represented in hexadecimal as 4D 5A... " << endl
            << "obot -V               # version " << endl
            << "obot -VC              # version with comments " << endl;
    } else {
        cerr << "obot -b2048 text      " << endl
            << "obot -c20 text        " << endl
            << "obot -m3 text         " << endl
            << "obot -m3 -s\\x2C text  " << endl
            << "obot -m45 -r20 text   " << endl
            << "obot exe              " << endl
            << "obot -V               " << endl
            << "obot -VC              " << endl;
    }

    exit(1);
}
