#include "rufeol.h"

void versionGuide(double v, bool comments) {
    using namespace std;

    cerr << "rufeol Version " << v << "\n" << endl;

    if(comments) {
        cerr << "rufeol -m csv        # Remove a separator from every end of line. " << endl
            << "rufeol -u3 text      # Remove 3 unnecessary characters from every end of line. " << endl
            << "rufeol -u3 text new  # Read text to produce a new file. " << endl
            << "rufeol -u3 -r text   # Every line includes 0Dh. " << endl
            << "rufeol -u3 -y text   # Do not remove binary.tmp " << endl
            << "rufeol -u3 -w2 text  # Read a double-spaced text to produce a draft. " << endl
            << "rufeol -x2 text      # Read a double-spaced text to produce a draft. " << endl
            << "rufeol -V            # version " << endl
            << "rufeol -VC           # version with comments " << endl
            << "rufeol --help        # version with comments " << endl;
    } else {
        cerr << "rufeol -m csv        " << endl
            << "rufeol -u3 text      " << endl
            << "rufeol -u3 text new  " << endl
            << "rufeol -u3 -r text   " << endl
            << "rufeol -u3 -y text   " << endl
            << "rufeol -u3 -w2 text  " << endl
            << "rufeol -x2 text      " << endl
            << "rufeol -V            " << endl
            << "rufeol -VC           " << endl
            << "rufeol --help        " << endl;
    }

    exit(1);
}
