#include "kanji_union.h"

char EMPTY[1] = {0};
char extraPathName[ FILE_NAME_SIZE + 1 ];
extern FIELD_POINTER *fields_list; // array of fields

bool openClose(char *file_name) {
    using namespace std;

    bool b = true;
    ifstream in(file_name);
    if( in.fail() ) {
        b = false;
    }

    return b;
}

bool openClose(std::string & fileName) {
    using namespace std;

    bool b = true;
    ifstream in( fileName.c_str() );
    if( in.fail() ) {
        b = false;
    }

    return b;
}

// strcpy(data, getenv("Path") );
char *CommandPath::path_name(char *extra) {
    Dividing *d = new Dividing(';');
    int fieldCount = d->complementing_fields_list(data, extra, '\\');

    for(int i = 0; i < fieldCount; ++i) {
        if( openClose( fields_list[i] ) ) {
            strcpy(extraPathName, fields_list[i]);
            delete d;
            return extraPathName;
        }

    }

    delete d;
    return &EMPTY[0];
}

std::string CommandPath::pathName(const char *extra) {
    using namespace std;

    char file_name[ FILE_NAME_SIZE + 1 ];
    file_name[FILE_NAME_SIZE] = '\0';
    strncpy(file_name, extra, FILE_NAME_SIZE);

    Dividing *d = new Dividing(';');
    int fieldCount = d->complementing_fields_list(data, file_name, '\\');

    for(int i = 0; i < fieldCount; ++i) {
        if( openClose( fields_list[i] ) ) {
            strcpy(extraPathName, fields_list[i]);
            delete d;

            string fullPath(extraPathName);
            return fullPath;
        }

    }

    delete d;
    string empty("");
    return empty;
}

